<?xml version="1.0" encoding="UTF-8"?>
<!DOCTYPE topic PUBLIC "-//OASIS//DTD DITA Topic//EN" "topic.dtd">
<topic id="dcpp_how_to_use_a_key_value_from_the_map_in_the_css">
    <title>How to Use  Data Elements from the Map to Create Custom PDF Metadata</title>
  <prolog>
    <metadata>
      <keywords>
        <indexterm product="author developer editor authorEclipse developerEclipse editorEclipse"
            ><ph keyref="pdf-html5-transformation"/>
          <indexterm>Metadata<indexterm>Key values</indexterm></indexterm></indexterm>
        <indexterm product="author developer editor authorEclipse developerEclipse editorEclipse"
            ><ph keyref="pdf-html5-transformation"/>
          <indexterm>Metadata<indexterm>Use key value in CSS</indexterm></indexterm></indexterm>
        <indexterm product="pdf-css ope">Metadata<indexterm>Key values</indexterm></indexterm>
        <indexterm product="pdf-css ope">Metadata<indexterm>Use key value in
          CSS</indexterm></indexterm>
      </keywords>
    </metadata>
  </prolog>
    <body>
        <p id="p_akr_cgk_54b">To use a key value in the CSS, the key must be referenced from the content (either a
      topic or map). </p>
		<p id="p_bkr_cgk_54b">If you do not have it referenced, you may force a reference by using the
        <xmlelement>topicmeta</xmlelement> or <xmlelement>bookmeta</xmlelement> section of your map
      and a <xmlelement>data</xmlelement> element. This has no effect on the published content, but
      allows the CSS rules to use its content.</p>
		<codeblock  id="codeblock_ckr_cgk_54b">  &lt;bookmeta>
    ....
    &lt;data keyref="my_key"/>
    ....
  &lt;/bookmeta></codeblock>
		<p id="p_dkr_cgk_54b">This is expanded in the merged HTML file to: </p>
		<codeblock  id="codeblock_ekr_cgk_54b">&lt;div class="- map/topicmeta bookmap/bookmeta topicmeta bookmeta">
	...
	&lt;div keyref="my_key" class="- topic/data data">
		&lt;div class="- topic/keyword keyword">KEY VALUE&lt;/div>
	&lt;/div>
	...
&lt;/div></codeblock>
		<p id="p_fkr_cgk_54b">Suppose that you need the expanded key value in the footer of the publication. You can define a
      string-set on this <codeph>data</codeph> element:</p>
		<codeblock  id="codeblock_gkr_cgk_54b">*[class ~= "topic/data"][keyref="my_key"] {
	string-set: key-string content(text);
}
@page {	
	@bottom-left {
		content: "My key is: " string(key-string) !important;		
	}
}</codeblock>
		<p id="p_hkr_cgk_54b">Or you can use the value from a <codeph>:before</codeph> pseudo-element, like the one for the
      title:</p>
		<codeblock  id="codeblock_ikr_cgk_54b">*[class ~= "topic/title"]:before {
	content: oxy_xpath("//*[contains(@class, 'topic/data')][@keyref = 'my_key']//text()");
}</codeblock>
		<p id="p_jkr_cgk_54b">Another use-case is to use the key as a source for a custom PDF document property:</p>
		<codeblock  id="codeblock_kkr_cgk_54b">*[class ~= "topic/data"][keyref="my_key"] {
	-oxy-pdf-meta-custom: attr(keyref) content(text);
}</codeblock>
    </body>
</topic>
